/* formComboBoxDef.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef FORMCOMBOBOXDEF_H
#define FORMCOMBOBOXDEF_H

#include "labeledWidget.h"

#include <gtk--.h>
#include <string>
#include <map>

// These classes define everything you need to know about the various
// combo boxes the user has defined for putting on his/her forms.

class FormComboItemDef {
public:
  static FormComboItemDef &find_item(int combo_item_id, const string &label);

  int _combo_item_id;
  string _label;

private:
  FormComboItemDef(int combo_item_id, const string &label);

  typedef map<int, FormComboItemDef> ItemMap;
  static ItemMap _items;
};


class FormComboBoxDef {
public:
  static FormComboBoxDef &find_box(int combo_box_id);

  LabeledCombo *make_widget(const string &widget_label) const;
  int get_id(const string &combo_item_label) const;
  string get_label(int combo_item_id) const;

  int _combo_box_id;
  string _description;
  typedef vector<FormComboItemDef *> Items;
  Items _items;

private:
  FormComboBoxDef(int combo_box_id);

  typedef map<int, FormComboBoxDef> BoxMap;
  static BoxMap _boxes;
};

#endif
